"""
Enumerations for the data
"""

import polars as pl

from .constants import (
    CONFIDENCES,
    GAS_LIST,
    ORIGINAL_INVENTORY_SECTORS,
    SECTORS,
    SUBSECTORS,
)

# The list was generated with the following snippet:
# countries = pl.read_csv("https://gitlab.com/pasosdeJesus/division-politica/-/raw/main/PAISES_ISO_2022-ampliado.csv?inline=false")
# iso3_enum = pl.Enum(sorted(list(countries["alfa3"]) + ["XKX"]))
_countries = (
    [
        "ABW",
        "AFG",
        "AGO",
        "AIA",
        "ALA",
        "ALB",
        "AND",
        "ARE",
        "ARG",
        "ARM",
        "ASM",
        "ATA",
        "ATF",
        "ATG",
        "AUS",
        "AUT",
        "AZE",
        "BDI",
        "BEL",
        "BEN",
        "BES",
        "BFA",
        "BGD",
        "BGR",
        "BHR",
        "BHS",
        "BIH",
        "BLM",
        "BLR",
        "BLZ",
        "BMU",
        "BOL",
        "BRA",
        "BRB",
        "BRN",
        "BTN",
        "BVT",
        "BWA",
        "CAF",
        "CAN",
        "CCK",
        "CHE",
        "CHL",
        "CHN",
        "CIV",
        "CMR",
        "COD",
        "COG",
        "COK",
        "COL",
        "COM",
        "CPV",
        "CRI",
        "CUB",
        "CUW",
        "CXR",
        "CYM",
        "CYP",
        "CZE",
        "DEU",
        "DJI",
        "DMA",
        "DNK",
        "DOM",
        "DZA",
        "ECU",
        "EGY",
        "ERI",
        "ESH",
        "ESP",
        "EST",
        "ETH",
        "FIN",
        "FJI",
        "FLK",
        "FRA",
        "FRO",
        "FSM",
        "GAB",
        "GBR",
        "GEO",
        "GGY",
        "GHA",
        "GIB",
        "GIN",
        "GLP",
        "GMB",
        "GNB",
        "GNQ",
        "GRC",
        "GRD",
        "GRL",
        "GTM",
        "GUF",
        "GUM",
        "GUY",
        "HKG",
        "HMD",
        "HND",
        "HRV",
        "HTI",
        "HUN",
        "IDN",
        "IMN",
        "IND",
        "IOT",
        "IRL",
        "IRN",
        "IRQ",
        "ISL",
        "ISR",
        "ITA",
        "JAM",
        "JEY",
        "JOR",
        "JPN",
        "KAZ",
        "KEN",
        "KGZ",
        "KHM",
        "KIR",
        "KNA",
        "KOR",
        "KWT",
        "LAO",
        "LBN",
        "LBR",
        "LBY",
        "LCA",
        "LIE",
        "LKA",
        "LSO",
        "LTU",
        "LUX",
        "LVA",
        "MAC",
        "MAF",
        "MAR",
        "MCO",
        "MDA",
        "MDG",
        "MDV",
        "MEX",
        "MHL",
        "MKD",
        "MLI",
        "MLT",
        "MMR",
        "MNE",
        "MNG",
        "MNP",
        "MOZ",
        "MRT",
        "MSR",
        "MTQ",
        "MUS",
        "MWI",
        "MYS",
        "MYT",
        "NAM",
        "NCL",
        "NER",
        "NFK",
        "NGA",
        "NIC",
        "NIU",
        "NLD",
        "NOR",
        "NPL",
        "NRU",
        "NZL",
        "OMN",
        "PAK",
        "PAN",
        "PCN",
        "PER",
        "PHL",
        "PLW",
        "PNG",
        "POL",
        "PRI",
        "PRK",
        "PRT",
        "PRY",
        "PSE",
        "PYF",
        "QAT",
        "REU",
        "ROU",
        "RUS",
        "RWA",
        "SAU",
        "SDN",
        "SEN",
        "SGP",
        "SGS",
        "SHN",
        "SJM",
        "SLB",
        "SLE",
        "SLV",
        "SMR",
        "SOM",
        "SPM",
        "SRB",
        "SSD",
        "STP",
        "SUR",
        "SVK",
        "SVN",
        "SWE",
        "SWZ",
        "SXM",
        "SYC",
        "SYR",
        "TCA",
        "TCD",
        "TGO",
        "THA",
        "TJK",
        "TKL",
        "TKM",
        "TLS",
        "TON",
        "TTO",
        "TUN",
        "TUR",
        "TUV",
        "TWN",
        "TZA",
        "UGA",
        "UKR",
        "UMI",
        "URY",
        "USA",
        "UZB",
        "VAT",
        "VCT",
        "VEN",
        "VGB",
        "VIR",
        "VNM",
        "VUT",
        "WLF",
        "WSM",
        "XKX",
        "YEM",
        "ZAF",
        "ZMB",
        "ZWE",
    ]
    + [
        "ZNC",
        "UNK",  # TODO: decide if UNK should be null instead
        "SCG",
    ]
    + [
        "XAD",  # New code in V3
    ]
)

iso3_enum = pl.Enum(_countries)

gas_enum = pl.Enum(GAS_LIST)

temporal_granularity_enum = pl.Enum(["annual", "other", "month", "week", "day", "hour"])

# Inventory sectors
INTERNATIONAL_AVIATION = "international-aviation"
ROAD_TRANSPORTATION = "road-transportation"
INTERNATIONAL_SHIPPING = "international-shipping"
ELECTRICITY_GENERATION = "electricity-generation"
DOMESTIC_SHIPPING = "domestic-shipping"
DOMESTIC_AVIATION = "domestic-aviation"
INVENTORY_SECTORS = [
    INTERNATIONAL_AVIATION,
    ROAD_TRANSPORTATION,
    INTERNATIONAL_SHIPPING,
    ELECTRICITY_GENERATION,
    DOMESTIC_SHIPPING,
    DOMESTIC_AVIATION,
]
inventory_sector_enum = pl.Enum(INVENTORY_SECTORS)

# Confidence levels

confidence_level_enum = pl.Enum(CONFIDENCES)

subsector_enum = pl.Enum(SUBSECTORS)

sector_enum = pl.Enum(SECTORS)

original_inventory_sector_enum = pl.Enum(ORIGINAL_INVENTORY_SECTORS)
